import{s as me,n as fe,o as pe}from"../chunks/scheduler.889ebb13.js";import{S as ue,i as he,g as o,s as l,r as D,A as ce,h as s,f as n,c as a,j as se,u as O,x as r,k as re,y as ge,a as i,v as R,d as X,t as J,w as K}from"../chunks/index.ca18042b.js";import{H as N}from"../chunks/Heading.3daa581c.js";import{E as we}from"../chunks/EditOnGithub.2e95618d.js";function de(Q){let m,C,b,M,f,T,p,V="Welcome to this second unit, where <strong>we’ll explore different agentic frameworks</strong> that can be used to build powerful agentic applications.",A,u,Y="We will study:",H,h,Z='<li>In Unit 2.1: <a href="https://huggingface.co/docs/smolagents/en/index" rel="nofollow">Smolagents</a></li> <li>In Unit 2.2: <a href="https://www.llamaindex.ai/" rel="nofollow">LlamaIndex</a></li> <li>In Unit 2.3: <a href="https://www.langchain.com/langgraph" rel="nofollow">LangGraph</a></li>',P,c,ee="Let’s dive in! 🕵",U,g,F,w,te="An agentic framework is <strong>not always needed when building an application around LLMs</strong>. They provide flexibility in the workflow to efficiently solve a specific task, but they’re not always necessary.",E,d,ne="Sometimes, <strong>predefined workflows are sufficient</strong> to fulfill user requests, and there is no real need for an agentic framework. If the approach to build an agent is simple, like a chain of prompts, using plain code may be enough. The advantage is that the developer will have <strong>full control and understanding of their system without abstractions</strong>.",I,v,ie="However, when the workflow becomes more complex, such as letting an LLM call functions or using multiple agents, these abstractions start to become helpful.",S,x,le="Considering these ideas, we can already identify the need for some features:",j,$,ae="<li>An <em>LLM engine</em> that powers the system.</li> <li>A list of tools the agent can access.</li> <li>A <em>parser</em> for extracting tool calls from the LLM output.</li> <li>A <em>system prompt</em> synced with the parser.</li> <li>A <em>memory system</em>.</li> <li><em>Error logging and retry mechanisms</em> to control LLM mistakes.</li>",q,L,W,k,oe='<thead><tr><th>Framework</th> <th>Description</th> <th>Unit Author</th></tr></thead> <tbody><tr><td><a href="./smolagents/introduction">smolagents</a></td> <td>Agents framework developed by Hugging Face.</td> <td>Sergio Paniego - <a href="https://huggingface.co/sergiopaniego" rel="nofollow">HF</a> - <a href="https://x.com/sergiopaniego" rel="nofollow">X</a> - <a href="https://www.linkedin.com/in/sergio-paniego-blanco" rel="nofollow">Linkedin</a></td></tr></tbody>',z,_,G,y,B;return f=new N({props:{title:"Introduction to Agentic Frameworks",local:"introduction-to-agentic-frameworks",headingTag:"h1"}}),g=new N({props:{title:"When to Use an Agentic Framework",local:"when-to-use-an-agentic-framework",headingTag:"h2"}}),L=new N({props:{title:"Agentic Frameworks Units",local:"agentic-frameworks-units",headingTag:"h2"}}),_=new we({props:{source:"https://github.com/huggingface/agents-course/blob/main/units/en/unit2/introduction.mdx"}}),{c(){m=o("meta"),C=l(),b=o("p"),M=l(),D(f.$$.fragment),T=l(),p=o("p"),p.innerHTML=V,A=l(),u=o("p"),u.textContent=Y,H=l(),h=o("ul"),h.innerHTML=Z,P=l(),c=o("p"),c.textContent=ee,U=l(),D(g.$$.fragment),F=l(),w=o("p"),w.innerHTML=te,E=l(),d=o("p"),d.innerHTML=ne,I=l(),v=o("p"),v.textContent=ie,S=l(),x=o("p"),x.textContent=le,j=l(),$=o("ul"),$.innerHTML=ae,q=l(),D(L.$$.fragment),W=l(),k=o("table"),k.innerHTML=oe,z=l(),D(_.$$.fragment),G=l(),y=o("p"),this.h()},l(e){const t=ce("svelte-u9bgzb",document.head);m=s(t,"META",{name:!0,content:!0}),t.forEach(n),C=a(e),b=s(e,"P",{}),se(b).forEach(n),M=a(e),O(f.$$.fragment,e),T=a(e),p=s(e,"P",{"data-svelte-h":!0}),r(p)!=="svelte-hlqese"&&(p.innerHTML=V),A=a(e),u=s(e,"P",{"data-svelte-h":!0}),r(u)!=="svelte-5kufvb"&&(u.textContent=Y),H=a(e),h=s(e,"UL",{"data-svelte-h":!0}),r(h)!=="svelte-o6hh8"&&(h.innerHTML=Z),P=a(e),c=s(e,"P",{"data-svelte-h":!0}),r(c)!=="svelte-1r1x28z"&&(c.textContent=ee),U=a(e),O(g.$$.fragment,e),F=a(e),w=s(e,"P",{"data-svelte-h":!0}),r(w)!=="svelte-mk5673"&&(w.innerHTML=te),E=a(e),d=s(e,"P",{"data-svelte-h":!0}),r(d)!=="svelte-1xx3jm"&&(d.innerHTML=ne),I=a(e),v=s(e,"P",{"data-svelte-h":!0}),r(v)!=="svelte-1ew78qv"&&(v.textContent=ie),S=a(e),x=s(e,"P",{"data-svelte-h":!0}),r(x)!=="svelte-tt5p1j"&&(x.textContent=le),j=a(e),$=s(e,"UL",{"data-svelte-h":!0}),r($)!=="svelte-60d9wo"&&($.innerHTML=ae),q=a(e),O(L.$$.fragment,e),W=a(e),k=s(e,"TABLE",{"data-svelte-h":!0}),r(k)!=="svelte-1l1tw5j"&&(k.innerHTML=oe),z=a(e),O(_.$$.fragment,e),G=a(e),y=s(e,"P",{}),se(y).forEach(n),this.h()},h(){re(m,"name","hf:doc:metadata"),re(m,"content",ve)},m(e,t){ge(document.head,m),i(e,C,t),i(e,b,t),i(e,M,t),R(f,e,t),i(e,T,t),i(e,p,t),i(e,A,t),i(e,u,t),i(e,H,t),i(e,h,t),i(e,P,t),i(e,c,t),i(e,U,t),R(g,e,t),i(e,F,t),i(e,w,t),i(e,E,t),i(e,d,t),i(e,I,t),i(e,v,t),i(e,S,t),i(e,x,t),i(e,j,t),i(e,$,t),i(e,q,t),R(L,e,t),i(e,W,t),i(e,k,t),i(e,z,t),R(_,e,t),i(e,G,t),i(e,y,t),B=!0},p:fe,i(e){B||(X(f.$$.fragment,e),X(g.$$.fragment,e),X(L.$$.fragment,e),X(_.$$.fragment,e),B=!0)},o(e){J(f.$$.fragment,e),J(g.$$.fragment,e),J(L.$$.fragment,e),J(_.$$.fragment,e),B=!1},d(e){e&&(n(C),n(b),n(M),n(T),n(p),n(A),n(u),n(H),n(h),n(P),n(c),n(U),n(F),n(w),n(E),n(d),n(I),n(v),n(S),n(x),n(j),n($),n(q),n(W),n(k),n(z),n(G),n(y)),n(m),K(f,e),K(g,e),K(L,e),K(_,e)}}}const ve='{"title":"Introduction to Agentic Frameworks","local":"introduction-to-agentic-frameworks","sections":[{"title":"When to Use an Agentic Framework","local":"when-to-use-an-agentic-framework","sections":[],"depth":2},{"title":"Agentic Frameworks Units","local":"agentic-frameworks-units","sections":[],"depth":2}],"depth":1}';function xe(Q){return pe(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class be extends ue{constructor(m){super(),he(this,m,xe,de,me,{})}}export{be as component};
