import{s as je,n as ze,o as Ee}from"../chunks/scheduler.889ebb13.js";import{S as Oe,i as Se,g as o,s,r as g,A as Ue,h as l,f as n,c as a,j as Re,u as m,x as r,k as Ge,y as We,a as i,v as c,d as f,t as d,w as u}from"../chunks/index.ca18042b.js";import{H as h}from"../chunks/Heading.3daa581c.js";import{E as Be}from"../chunks/EditOnGithub.2e95618d.js";function Ie($e){let p,q,I,J,w,N,$,ve='<img src="https://huggingface.co/datasets/huggingface/documentation-images/resolve/main/smolagents/license_to_call.png" alt="smolagents license to call"/>',D,v,ye='This module covers how to build effective agents using the <a href="https://github.com/huggingface/smolagents" rel="nofollow"><code>smolagents</code></a> library, which provides a lightweight framework for creating capable AI agents.',F,y,Y,b,be="This module provides a comprehensive overview of key concepts and practical strategies for building intelligent agents using <code>smolagents</code>. With so many open-source frameworks available, it’s essential to understand the components and capabilities that make <code>smolagents</code> a useful option or to determine when another solution might be a better fit. We’ll explore critical agent types, including code agents designed for software development tasks, tool calling agents for creating modular, function-driven workflows and retrieval agents that access and synthesize information. Additionally, we’ll cover the orchestration of multiple agents and the integration of vision capabilities and web browsing to unlock new possibilities for dynamic and context-aware applications.",K,T,Te="In this unit, Alfred, the agent from Unit 1, makes his return. This time, he’s using the <code>smolagents</code> framework for his internal workings. Together, we’ll explore the key concepts behind this framework as Alfred tackles various tasks. Alfred is organizing a party at the Wayne Manor while the Wayne family 🦇 is away, and he has plenty to do. Join us as we showcase his journey and how he handles these tasks with <code>smolagents</code>!",Q,x,xe='<img src="https://huggingface.co/datasets/agents-course/course-images/resolve/main/en/unit1/this-is-alfred.jpg" alt="Alfred the agent"/>',X,L,Z,M,ee,_,Le="<code>smolagents</code> is one of the many open-source agent frameworks available for application development. Alternative options include <code>LlamaIndex</code> and <code>LangGraph</code>, which are also covered in other modules in this course. This library offers several key features that might make it a great fit for specific use cases, but we should always consider all options when selecting a framework. This module explores the advantages and drawbacks of using <code>smolagents</code>, helping you make an informed decision based on your project’s requirements.",te,k,ne,A,Me="<code>CodeAgents</code> are the primary type of agent in <code>smolagents</code>. Instead of generating JSON or text, these agents produce Python code to perform actions. This module explores their purpose, functionality, and how they work, along with hands-on examples to showcase their capabilities.",ie,C,se,H,_e="<code>ToolCallingAgents</code> are the second type of agent supported by <code>smolagents. Unlike </code>CodeAgents<code>, which generate Python code, these agents rely on JSON/text blobs that the system must parse and interpret to execute actions. This module covers their functionality, their key differences from </code>CodeAgents`, and it provides a coding example to illustrate their usage.",ae,P,oe,R,ke="Tools are functions that an LLM can use within an agentic system, acting as essential building blocks for agent behavior. This module covers how to create tools, their structure, and different implementation methods using the <code>Tool</code> class or the <code>@tool</code> decorator. You’ll also learn about the default toolbox, how to share tools with the community, and how to load community-contributed tools for use in your agents.",le,G,re,j,Ae="Retrieval agents combine models with knowledge bases, allowing them to search, synthesize, and retrieve information from multiple sources. They leverage vector stores for efficient retrieval and implement <strong>Retrieval-Augmented Generation (RAG)</strong> patterns. These agents are particularly useful for integrating web search with custom knowledge bases while maintaining conversation context through memory systems. This module explores implementation strategies, including fallback mechanisms for robust information retrieval.",ge,z,me,E,Ce="Orchestrating multiple agents effectively is crucial for building powerful, multi-agent systems. By combining agents with different capabilities—such as a web search agent with a code execution agent—you can create more sophisticated solutions. This module focuses on designing, implementing, and managing multi-agent systems to maximize efficiency and reliability.",ce,O,fe,S,He="Vision agents extend traditional agent capabilities by incorporating <strong>Vision-Language Models (VLMs)</strong>, enabling them to process and interpret visual information. This module explores how to design and integrate VLM-powered agents, unlocking advanced functionalities like image-based reasoning, visual data analysis, and multimodal interactions.  We will also use vision agents to build a browser agent that can browse the web and extract information from it.",de,U,ue,W,Pe='<li><a href="https://huggingface.co/docs/smolagents" rel="nofollow">smolagents Documentation</a> - Official docs for the smolagents library</li> <li><a href="https://www.anthropic.com/research/building-effective-agents" rel="nofollow">Building Effective Agents</a> - Research paper on agent architectures</li> <li><a href="https://huggingface.co/docs/smolagents/tutorials/building_good_agents" rel="nofollow">Agent Guidelines</a> - Best practices for building reliable agents</li> <li><a href="https://langchain-ai.github.io/langgraph/" rel="nofollow">LangGraph Agents</a> - Additional examples of agent implementations</li> <li><a href="https://platform.openai.com/docs/guides/function-calling" rel="nofollow">Function Calling Guide</a> - Understanding function calling in LLMs</li> <li><a href="https://www.pinecone.io/learn/retrieval-augmented-generation/" rel="nofollow">RAG Best Practices</a> - Guide to implementing effective RAG</li>',he,B,pe,V,we;return w=new h({props:{title:"Introduction to smolagents",local:"introduction-to-smolagents",headingTag:"h1"}}),y=new h({props:{title:"Module Overview",local:"module-overview",headingTag:"h2"}}),L=new h({props:{title:"Contents",local:"contents",headingTag:"h2"}}),M=new h({props:{title:"1️⃣ Why Use smolagents",local:"1-why-use-smolagents",headingTag:"h3"}}),k=new h({props:{title:"2️⃣ CodeAgents",local:"2-codeagents",headingTag:"h3"}}),C=new h({props:{title:"3️⃣ ToolCallingAgents",local:"3-toolcallingagents",headingTag:"h3"}}),P=new h({props:{title:"4️⃣ Tools",local:"4-tools",headingTag:"h3"}}),G=new h({props:{title:"5️⃣ Retrieval Agents",local:"5-retrieval-agents",headingTag:"h3"}}),z=new h({props:{title:"6️⃣ Multi-Agent Systems",local:"6-multi-agent-systems",headingTag:"h3"}}),O=new h({props:{title:"7️⃣ Vision and Browser agents",local:"7-vision-and-browser-agents",headingTag:"h3"}}),U=new h({props:{title:"Resources",local:"resources",headingTag:"h2"}}),B=new Be({props:{source:"https://github.com/huggingface/agents-course/blob/main/units/en/unit2/smolagents/introduction.mdx"}}),{c(){p=o("meta"),q=s(),I=o("p"),J=s(),g(w.$$.fragment),N=s(),$=o("p"),$.innerHTML=ve,D=s(),v=o("p"),v.innerHTML=ye,F=s(),g(y.$$.fragment),Y=s(),b=o("p"),b.innerHTML=be,K=s(),T=o("p"),T.innerHTML=Te,Q=s(),x=o("p"),x.innerHTML=xe,X=s(),g(L.$$.fragment),Z=s(),g(M.$$.fragment),ee=s(),_=o("p"),_.innerHTML=Le,te=s(),g(k.$$.fragment),ne=s(),A=o("p"),A.innerHTML=Me,ie=s(),g(C.$$.fragment),se=s(),H=o("p"),H.innerHTML=_e,ae=s(),g(P.$$.fragment),oe=s(),R=o("p"),R.innerHTML=ke,le=s(),g(G.$$.fragment),re=s(),j=o("p"),j.innerHTML=Ae,ge=s(),g(z.$$.fragment),me=s(),E=o("p"),E.textContent=Ce,ce=s(),g(O.$$.fragment),fe=s(),S=o("p"),S.innerHTML=He,de=s(),g(U.$$.fragment),ue=s(),W=o("ul"),W.innerHTML=Pe,he=s(),g(B.$$.fragment),pe=s(),V=o("p"),this.h()},l(e){const t=Ue("svelte-u9bgzb",document.head);p=l(t,"META",{name:!0,content:!0}),t.forEach(n),q=a(e),I=l(e,"P",{}),Re(I).forEach(n),J=a(e),m(w.$$.fragment,e),N=a(e),$=l(e,"P",{"data-svelte-h":!0}),r($)!=="svelte-84al8y"&&($.innerHTML=ve),D=a(e),v=l(e,"P",{"data-svelte-h":!0}),r(v)!=="svelte-qlibd3"&&(v.innerHTML=ye),F=a(e),m(y.$$.fragment,e),Y=a(e),b=l(e,"P",{"data-svelte-h":!0}),r(b)!=="svelte-14xe374"&&(b.innerHTML=be),K=a(e),T=l(e,"P",{"data-svelte-h":!0}),r(T)!=="svelte-aelzj0"&&(T.innerHTML=Te),Q=a(e),x=l(e,"P",{"data-svelte-h":!0}),r(x)!=="svelte-13ihsp8"&&(x.innerHTML=xe),X=a(e),m(L.$$.fragment,e),Z=a(e),m(M.$$.fragment,e),ee=a(e),_=l(e,"P",{"data-svelte-h":!0}),r(_)!=="svelte-1ni1rta"&&(_.innerHTML=Le),te=a(e),m(k.$$.fragment,e),ne=a(e),A=l(e,"P",{"data-svelte-h":!0}),r(A)!=="svelte-bjc1l"&&(A.innerHTML=Me),ie=a(e),m(C.$$.fragment,e),se=a(e),H=l(e,"P",{"data-svelte-h":!0}),r(H)!=="svelte-n29dj7"&&(H.innerHTML=_e),ae=a(e),m(P.$$.fragment,e),oe=a(e),R=l(e,"P",{"data-svelte-h":!0}),r(R)!=="svelte-ubz54f"&&(R.innerHTML=ke),le=a(e),m(G.$$.fragment,e),re=a(e),j=l(e,"P",{"data-svelte-h":!0}),r(j)!=="svelte-6c13yn"&&(j.innerHTML=Ae),ge=a(e),m(z.$$.fragment,e),me=a(e),E=l(e,"P",{"data-svelte-h":!0}),r(E)!=="svelte-15o11ij"&&(E.textContent=Ce),ce=a(e),m(O.$$.fragment,e),fe=a(e),S=l(e,"P",{"data-svelte-h":!0}),r(S)!=="svelte-1gya1jz"&&(S.innerHTML=He),de=a(e),m(U.$$.fragment,e),ue=a(e),W=l(e,"UL",{"data-svelte-h":!0}),r(W)!=="svelte-99c63t"&&(W.innerHTML=Pe),he=a(e),m(B.$$.fragment,e),pe=a(e),V=l(e,"P",{}),Re(V).forEach(n),this.h()},h(){Ge(p,"name","hf:doc:metadata"),Ge(p,"content",Ve)},m(e,t){We(document.head,p),i(e,q,t),i(e,I,t),i(e,J,t),c(w,e,t),i(e,N,t),i(e,$,t),i(e,D,t),i(e,v,t),i(e,F,t),c(y,e,t),i(e,Y,t),i(e,b,t),i(e,K,t),i(e,T,t),i(e,Q,t),i(e,x,t),i(e,X,t),c(L,e,t),i(e,Z,t),c(M,e,t),i(e,ee,t),i(e,_,t),i(e,te,t),c(k,e,t),i(e,ne,t),i(e,A,t),i(e,ie,t),c(C,e,t),i(e,se,t),i(e,H,t),i(e,ae,t),c(P,e,t),i(e,oe,t),i(e,R,t),i(e,le,t),c(G,e,t),i(e,re,t),i(e,j,t),i(e,ge,t),c(z,e,t),i(e,me,t),i(e,E,t),i(e,ce,t),c(O,e,t),i(e,fe,t),i(e,S,t),i(e,de,t),c(U,e,t),i(e,ue,t),i(e,W,t),i(e,he,t),c(B,e,t),i(e,pe,t),i(e,V,t),we=!0},p:ze,i(e){we||(f(w.$$.fragment,e),f(y.$$.fragment,e),f(L.$$.fragment,e),f(M.$$.fragment,e),f(k.$$.fragment,e),f(C.$$.fragment,e),f(P.$$.fragment,e),f(G.$$.fragment,e),f(z.$$.fragment,e),f(O.$$.fragment,e),f(U.$$.fragment,e),f(B.$$.fragment,e),we=!0)},o(e){d(w.$$.fragment,e),d(y.$$.fragment,e),d(L.$$.fragment,e),d(M.$$.fragment,e),d(k.$$.fragment,e),d(C.$$.fragment,e),d(P.$$.fragment,e),d(G.$$.fragment,e),d(z.$$.fragment,e),d(O.$$.fragment,e),d(U.$$.fragment,e),d(B.$$.fragment,e),we=!1},d(e){e&&(n(q),n(I),n(J),n(N),n($),n(D),n(v),n(F),n(Y),n(b),n(K),n(T),n(Q),n(x),n(X),n(Z),n(ee),n(_),n(te),n(ne),n(A),n(ie),n(se),n(H),n(ae),n(oe),n(R),n(le),n(re),n(j),n(ge),n(me),n(E),n(ce),n(fe),n(S),n(de),n(ue),n(W),n(he),n(pe),n(V)),n(p),u(w,e),u(y,e),u(L,e),u(M,e),u(k,e),u(C,e),u(P,e),u(G,e),u(z,e),u(O,e),u(U,e),u(B,e)}}}const Ve='{"title":"Introduction to smolagents","local":"introduction-to-smolagents","sections":[{"title":"Module Overview","local":"module-overview","sections":[],"depth":2},{"title":"Contents","local":"contents","sections":[{"title":"1️⃣ Why Use smolagents","local":"1-why-use-smolagents","sections":[],"depth":3},{"title":"2️⃣ CodeAgents","local":"2-codeagents","sections":[],"depth":3},{"title":"3️⃣ ToolCallingAgents","local":"3-toolcallingagents","sections":[],"depth":3},{"title":"4️⃣ Tools","local":"4-tools","sections":[],"depth":3},{"title":"5️⃣ Retrieval Agents","local":"5-retrieval-agents","sections":[],"depth":3},{"title":"6️⃣ Multi-Agent Systems","local":"6-multi-agent-systems","sections":[],"depth":3},{"title":"7️⃣ Vision and Browser agents","local":"7-vision-and-browser-agents","sections":[],"depth":3}],"depth":2},{"title":"Resources","local":"resources","sections":[],"depth":2}],"depth":1}';function qe($e){return Ee(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Ye extends Oe{constructor(p){super(),Se(this,p,qe,Ie,je,{})}}export{Ye as component};
